;+
;NAME:
; makeps.pro
;PURPOSE:
; A simple function to reliably and consistently do postscript export
; Right now it will export whatever your last tplot command was(ie
; current plot)
;CALLING SEQUENCE:
; makeps
; -or-
; makeps,'filename'
;INPUT:
; a filename or nothing
;OUTPUT:
; a postscript file to the specified location
; errors, grays out all buttons while processing
;
;NOTES: Will append a .ps to your filename whether you like it or not
;       TODO: add an argument to accept a list of variables
;
;$LastChangedBy: pcruce $
;$LastChangedDate: 2007-10-12 13:56:36 -0700 (Fri, 12 Oct 2007) $
;$LastChangedRevision: 1679 $
;$URL: svn+ssh://thmsvn@ambrosia.ssl.berkeley.edu/repos/ssl_general/tags/tdas_3_00/misc/makeps.pro $
;
;-
pro makeps,filename

if(not keyword_set(filename)) then filename = 'tplotpostscript'

mydevice = !D.NAME  

myplot = !p 

SET_PLOT, 'PS' 

DEVICE, FILENAME=filename+'.ps',/color,bits_per_pixel=8

tplot

DEVICE, /CLOSE  

SET_PLOT, mydevice  

!p = myplot

end
